package tools.descartes.dql.connector.kieker;

import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

import edu.kit.ipd.descartes.solving.DMLModels;

public class ModelLoader {
	private ResourceSet resourceSet;
	private DMLModelFiles paths;
	
	public ModelLoader(DMLModelFiles paths) {
		this.paths = paths;
	}
	
	public DMLModels load() {
		DMLModels models = new DMLModels();
		models.setDeploymentModel(loadModel(paths.getDeploymentFile()));
		models.setUsageprofileModel(loadModel(paths.getUsageProfileFile()));
		return models;
	}
	
	public ResourceSet getResourceSet() {
		if (null == resourceSet)
			this.resourceSet = new ResourceSetImpl();
		return resourceSet;
	}

	private EObject loadModel(String filePath) {
		return loadModel(URI.createFileURI(filePath));
	}
	
	private EObject loadModel(URI uriToModelFile) {
		org.eclipse.emf.ecore.resource.Resource res = this.getResourceSet().getResource(uriToModelFile, true);
		if (res.getContents().get(0) instanceof EObject)
			return (EObject) res.getContents().get(0);
		return null;
	}
}
